﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim pnFondo As Panel
	Dim miWindow As Panel 
	
	Private wStartX, wStartY As Int
	Private wMoveInProgress As Boolean
	Private TouchSlop As Int
	Private wParent As Activity

End Sub

'Initializes the object. 
'Parent - The calling Activity. 
'Ancho -Ancho de la ventana de pedir datos
'Alto - Alto de la ventana de pedir datos
'
'Example:
'mw.Initialize(Activity, 100dip, 200dip)
Public Sub Initialize(Padre As Activity,  Ancho As Int, Alto As Int) As Panel

	wParent=Padre
	
	pnFondo.Initialize("")
	Padre.AddView(pnFondo,0,0,100%x,100%y)
	pnFondo.Color= Colors.ARGB(150,192,192,192) 'lo pongo en semitransparente para simular que estan desactivados
	
	miWindow.Initialize("miWindow") 
	miWindow.Color=Colors.Cyan
	pnFondo.AddView(miWindow,(100%x-Ancho)/2,70dip,Ancho,Alto) '
	'La centramos horizontalmente

	PonMarco(miWindow,Colors.Blue,6dip)
	
	Dim r As Reflector
	r.Target = miWindow
	r.SetOnTouchListener("Content_Touch")
	
	Dim r2 As Reflector
	r2.Target = pnFondo
	r2.SetOnTouchListener("pnFondo_Touch")

	Dim r1 As Reflector
	r1.Target = r1.RunStaticMethod("android.view.ViewConfiguration", "get", Array As Object(r.GetContext), Array As String("android.content.Context"))
	TouchSlop = r1.RunMethod("getScaledTouchSlop")
	
	Return miWindow
End Sub

Sub Ocultar
	pnFondo.Visible=False
End Sub

Sub Mostrar
	pnFondo.Visible=True
	pnFondo.BringToFront
End Sub

Sub PonMarco(Vista As View,Color As Int, Ancho As Float)
	Dim C As Canvas
	Dim R As Rect
	R.Initialize(0,0,Vista.Width,Vista.Height)
	C.Initialize(Vista)
	C.DrawRect(R,Color,False,Ancho)
End Sub


Private Sub pnFondo_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Return True
	' para que no haga nada cuando se pulse fuera de miWindow
End Sub

' Para que se mueva
Private Sub Content_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case 0 ' DOWN
			wStartX = X
			wStartY = Y
			wMoveInProgress = False
		Case 1 ' UP
			If wMoveInProgress Then
				wMoveInProgress = False
			End If
		Case 2 ' MOVE
			' We block the interception of touch events
			Dim r As Reflector
			r.Target = Sender
			If Sender Is ListView OR Sender Is ScrollView Then
				r.RunMethod2("requestDisallowInterceptTouchEvent", True, "java.lang.boolean")
			End If

			' Is the move big enough to be considered as a move ?
			Dim MoveQty As Int
			MoveQty = Sqrt(Power(Abs(X - wStartX), 2) + Power(Abs(Y - wStartY), 2))
			If wMoveInProgress OR MoveQty > TouchSlop Then
					MoveWin(miWindow.Left + X - wStartX, miWindow.Top + Y - wStartY, True)
				If Not(wMoveInProgress) Then
					wMoveInProgress = True
				End If
			End If
	End Select
	Return True 
End Sub

Public Sub getWidth As Int
	If miWindow.Width < 0 Then
		Dim r As Reflector, Largeur As Int
		r.Target = miWindow
		Largeur = r.RunMethod("getWidth")
		If Largeur = 0 Then
			DoEvents
			Largeur = r.RunMethod("getWidth")
		End If
		Return Largeur		
	Else
		Return miWindow.Width
	End If
End Sub

'Gets the window height
'If you want only the height of the content panel, call getContentHeight
Public Sub getHeight As Int
	If miWindow.Height < 0 Then
		Dim r As Reflector, Hauteur As Int
		r.Target = miWindow
		Hauteur = r.RunMethod("getHeight")
		If Hauteur = 0 Then
			DoEvents
			Hauteur = r.RunMethod("getHeight")
		End If
		Return Hauteur		
	Else
		Return miWindow.Height
	End If
End Sub
Private Sub CalcNewLeft(NewLeft As Int) As Int
	Dim StillVisible As Int = 100dip
	Return Max(StillVisible - getWidth, Min(NewLeft, wParent.Width - StillVisible))
End Sub
Private Sub CalcNewTop(NewTop As Int) As Int
	Dim StillVisible As Int = 100dip
	Return Max(StillVisible - getHeight, Min(NewTop, wParent.Height - StillVisible))
End Sub
Private Sub MoveWin(NewLeft As Int, NewTop As Int, CheckStillVisible As Boolean)
	If CheckStillVisible Then
		If NewLeft <> -1 Then
			miWindow.Left = CalcNewLeft(NewLeft)
		End If
		If NewTop <> -1 Then
			miWindow.Top = CalcNewTop(NewTop)
		End If
	Else
		If NewLeft <> -1 Then miWindow.Left = NewLeft
		If NewTop <> -1 Then miWindow.Top = NewTop
	End If
	'If SubExists(wModule, OnMoveWinSub) Then CallSub2(wModule, OnMoveWinSub, Me)
End Sub